Index: main/plugin-forms/src/org/ametys/plugins/forms/data/FormsContentClientSideElement.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/data/FormsContentClientSideElement.java	(revision 39963)
+++ main/plugin-forms/src/org/ametys/plugins/forms/data/FormsContentClientSideElement.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -19,24 +19,22 @@
 import java.util.List;
 import java.util.Map;
 
-import org.apache.avalon.framework.configuration.Configuration;
-import org.apache.avalon.framework.configuration.ConfigurationException;
 import org.apache.avalon.framework.service.ServiceException;
 import org.apache.avalon.framework.service.ServiceManager;
 import org.apache.commons.lang.StringUtils;
 
-import org.ametys.cms.clientsideelement.StaticMenu;
 import org.ametys.cms.repository.Content;
 import org.ametys.plugins.forms.Form;
 import org.ametys.plugins.forms.FormsException;
 import org.ametys.plugins.forms.jcr.FormPropertiesManager;
 import org.ametys.plugins.repository.AmetysObjectResolver;
+import org.ametys.runtime.ui.impl.StaticContextualClientSideElement;
 import org.ametys.runtime.util.I18nizableText;
 
 /**
  * This element creates a content button permitting to export the form data.
  */
-public class FormsContentClientSideElement extends StaticMenu
+public class FormsContentClientSideElement extends StaticContextualClientSideElement
 {
     
     /** The form properties manager. */
@@ -54,16 +52,11 @@
     }
     
     @Override
-    public void configure(Configuration configuration) throws ConfigurationException
-    {
-        super.configure(configuration);
-    }
-    
-    @Override
     public Map<String, I18nizableText> getCurrentParameters(Map<String, Object> parameters)
     {
         Map<String, I18nizableText> results = new HashMap<String, I18nizableText>();
         
+        @SuppressWarnings("unchecked")
         List<String> contentIds = (List<String>) parameters.get("targets");
         
         int formCount = 0;
Index: main/plugin-forms/src/org/ametys/plugins/forms/data/FormsListGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/data/FormsListGenerator.java	(revision 0)
+++ main/plugin-forms/src/org/ametys/plugins/forms/data/FormsListGenerator.java	(revision 0)
@@ -0,0 +1,124 @@
+package org.ametys.plugins.forms.data;
+
+import java.io.IOException;
+import java.net.URI;
+import java.util.Date;
+import java.util.List;
+import java.util.Map;
+
+import javax.jcr.Node;
+
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.ProcessingException;
+import org.apache.cocoon.generation.ServiceableGenerator;
+import org.apache.cocoon.xml.AttributesImpl;
+import org.apache.cocoon.xml.XMLUtils;
+import org.apache.commons.lang.StringUtils;
+import org.xml.sax.SAXException;
+
+import org.ametys.cms.transformation.xslt.URIDecoder;
+import org.ametys.plugins.forms.Form;
+import org.ametys.plugins.forms.jcr.FormPropertiesManager;
+import org.ametys.plugins.forms.table.FormTableManager;
+import org.ametys.runtime.util.parameter.ParameterHelper;
+
+/**
+ * This generator is used in order to retrieve information on the forms 
+ * of a given site in a given language
+ */
+public class FormsListGenerator extends ServiceableGenerator
+{
+    /** Component gathering methods to retrieve forms */
+    private FormPropertiesManager _formPropertiesManager;
+    
+    /** The form data manager */
+    private FormTableManager _formTableManager;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        _formPropertiesManager = (FormPropertiesManager) serviceManager.lookup(FormPropertiesManager.ROLE); 
+        _formTableManager = new FormTableManager();
+    }
+    
+    @Override
+    public void generate() throws IOException, SAXException, ProcessingException
+    {
+        String siteName = parameters.getParameter("siteName", "");
+        String language = parameters.getParameter("language", "");
+        
+        if (StringUtils.isEmpty(siteName) || StringUtils.isEmpty(language))
+        {
+            throw new ProcessingException("The site name and language must be provided.");
+        }
+        
+        contentHandler.startDocument();
+        XMLUtils.startElement(contentHandler, "forms");
+        
+        try
+        {
+            List<Node> contentNodes = _formPropertiesManager.getFormContentNodes(siteName, language);
+            
+            AttributesImpl attrs = new AttributesImpl();
+            for (Node contentNode : contentNodes)
+            {
+                String contentName = contentNode.getName();
+                
+                // Get the corresponding forms
+                List<Form> forms = _formPropertiesManager.getForms(contentNode);
+                for (Form form : forms)
+                {
+                    Map<String, FieldValue> columns = _formTableManager.getColumns(form);
+                    List<UserEntry> entries = _formTableManager.getSubmissions(form, columns, 0, Integer.MAX_VALUE);
+                    int totalSubmissions = _formTableManager.getTotalSubmissions(form.getId());
+                    Date lastSubmissionDate = _getLastSubmissionDate(entries);
+                    attrs.addCDATAAttribute("id", form.getId());
+                    attrs.addCDATAAttribute("encodedLabel", new URI(null, null,  URIDecoder.decode(form.getLabel()).replace('/', ' '), null).getRawPath());
+                    
+                    XMLUtils.startElement(contentHandler, "form", attrs);
+                    
+                    XMLUtils.createElement(contentHandler, "name", URIDecoder.decode(form.getLabel()));
+                    XMLUtils.createElement(contentHandler, "contentName", contentName);
+                    XMLUtils.createElement(contentHandler, "answersAmount", String.valueOf(totalSubmissions));
+                    XMLUtils.createElement(contentHandler, "lastAnswer", lastSubmissionDate != null ? ParameterHelper.valueToString(lastSubmissionDate) : "");
+                    
+                    XMLUtils.endElement(contentHandler, "form");
+                    
+                    attrs.clear();
+                }
+            }
+            
+            XMLUtils.endElement(contentHandler, "forms");
+            contentHandler.endDocument();
+        }
+        catch (Exception e)
+        {
+            throw new ProcessingException("An error occurred while processing the forms list.", e);
+        }
+    }
+    
+    /**
+     * Get the date of the most recent {@link UserEntry}
+     * @param entries the list of entries
+     * @return the date of the most recent entry
+     */
+    private Date _getLastSubmissionDate (List<UserEntry> entries)
+    {
+        Date lastSubmissionDate = null;
+        if (entries.size() > 0)
+        {
+            lastSubmissionDate = entries.get(0).getCreationDate();
+            for (UserEntry entry : entries)
+            {
+                Date creationDate = entry.getCreationDate();
+                if (lastSubmissionDate.before(creationDate))
+                {
+                    lastSubmissionDate = creationDate;
+                }
+            }
+        }
+        
+        return lastSubmissionDate;
+    }
+}
Index: main/plugin-forms/src/org/ametys/plugins/forms/jcr/FormPropertiesManager.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/jcr/FormPropertiesManager.java	(revision 39963)
+++ main/plugin-forms/src/org/ametys/plugins/forms/jcr/FormPropertiesManager.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -73,6 +73,12 @@
     /** Forms node name. */
     public static final String FORMS_NODE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":forms";
     
+    /** Language property */
+    public static final String LANGUAGE_PROPERTY = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":language";
+
+    /** Site property */
+    public static final String SITE_PROPERTY = RepositoryConstants.NAMESPACE_PREFIX+ ":site";
+    
     /** "ID" property name. */
     public static final String FORM_PROPERTY_ID = RepositoryConstants.NAMESPACE_PREFIX + ":id";
     
@@ -136,7 +142,18 @@
     
     /**
      * Get a form from the repository.
-     * @param siteName the site name.
+     * @param id the form ID.
+     * @return the Form or null if no form with this ID exists.
+     * @throws FormsException if an error occurs.
+     */
+    public Form getForm(String id) throws FormsException
+    {
+        return getForm(null, id);
+    }
+    
+    /**
+     * Get a form from the repository.
+     * @param siteName the site name
      * @param id the form ID.
      * @return the Form or null if no form with this ID exists.
      * @throws FormsException if an error occurs.
@@ -150,8 +167,15 @@
             
             Form form = null;
             
-            String xpathQuery = "//element(*, ametys:content)/" + FORMS_NODE + "/*[@" + FORM_PROPERTY_ID + " = '" + id + "']";
+            // Build the query
+            String xpathQuery = "//element(*, ametys:content)";
+            if (siteName != null)
+            {
+                xpathQuery += "[@" + SITE_PROPERTY + "='" + siteName + "']";
+            }
+            xpathQuery += "/" + FORMS_NODE + "/*[@" + FORM_PROPERTY_ID + " = '" + id + "']";
             
+            // Execute
             QueryManager queryManager = session.getWorkspace().getQueryManager();
             Query query = queryManager.createQuery(xpathQuery, Query.XPATH);
             NodeIterator nodeIterator = query.execute().getNodes();
@@ -159,7 +183,6 @@
             if (nodeIterator.hasNext())
             {
                 Node node = nodeIterator.nextNode();
-                
                 form = _extractForm(node);
             }
             
@@ -234,6 +257,89 @@
     }
     
     /**
+     * Get all the contents containing at least one form of the given site with the given language
+     * @param siteName the site name.
+     * @param language the language
+     * @return the forms' list or null if none was found
+     * @throws FormsException if an error occurs.
+     */
+    public List<Node> getFormContentNodes(String siteName, String language) throws FormsException
+    {
+        List<Node> contentNodes = new ArrayList<Node> ();
+        Session session = null;
+        try
+        {
+            session = _repository.login();
+            
+            String xpathQuery = "//element(*, ametys:content)[@" + SITE_PROPERTY + " = '" + siteName + "' and @" + LANGUAGE_PROPERTY + " = '" + language + "']";
+            
+            QueryManager queryManager = session.getWorkspace().getQueryManager();
+            Query query = queryManager.createQuery(xpathQuery, Query.XPATH);
+            NodeIterator nodeIterator = query.execute().getNodes();
+            
+            while (nodeIterator.hasNext())
+            {
+                Node node = nodeIterator.nextNode();
+                if (node.hasNode(FORMS_NODE))
+                {
+                    contentNodes.add(node);
+                }
+            }
+            
+            return contentNodes;
+        }
+        catch (RepositoryException e)
+        {
+            throw new FormsException("Error executing the query to find the forms of the site '" + siteName + "' and of language '" + language + "'.", e);
+        }
+        finally
+        {
+            if (session != null)
+            {
+                session.logout();
+            }
+        }
+    }    
+    
+    /**
+     * Extract all the form objects from a node
+     * @param node the node
+     * @return the forms list of this node
+     * @throws FormsException if an error occurs
+     * @throws RepositoryException if an error occurs when getting the properties of a node
+     */
+    public List<Form> getForms(Node node) throws FormsException, RepositoryException
+    {
+        List<Form> forms = new ArrayList<Form> ();
+        try
+        {
+            if (node.hasNode(FORMS_NODE))
+            {
+                Node formsNode = node.getNode(FORMS_NODE);
+                if (formsNode != null)
+                {
+                    NodeIterator formsNodeIterator = formsNode.getNodes();
+                    while (formsNodeIterator.hasNext())
+                    {
+                        Node formNode = formsNodeIterator.nextNode();
+                        Form form = _extractForm(formNode);
+                        if (form != null)
+                        {
+                            forms.add(form);
+                        }
+                    }
+                }
+            }
+            
+            return forms;
+        }
+        catch (RepositoryException e)
+        {
+            throw new FormsException("Error executing the query to find the forms of the node '" + node.getName() + "' (" + node.getIdentifier() + ").", e);
+        }
+    }
+    
+    /**
      * Store the properties of a form in the repository.
      * @param siteName the site name.
      * @param form the form object.
Index: main/plugin-forms/src/org/ametys/plugins/forms/processing/FormResultsGenerator.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/processing/FormResultsGenerator.java	(revision 39963)
+++ main/plugin-forms/src/org/ametys/plugins/forms/processing/FormResultsGenerator.java	(working copy)
@@ -38,6 +38,7 @@
 public class FormResultsGenerator extends AbstractGenerator
 {
 
+    @SuppressWarnings("unchecked")
     @Override
     public void generate() throws IOException, SAXException, ProcessingException
     {
Index: main/plugin-forms/src/org/ametys/plugins/forms/processing/GetContentAction.java
===================================================================
--- main/plugin-forms/src/org/ametys/plugins/forms/processing/GetContentAction.java	(revision 39963)
+++ main/plugin-forms/src/org/ametys/plugins/forms/processing/GetContentAction.java	(working copy)
@@ -15,7 +15,6 @@
  */
 package org.ametys.plugins.forms.processing;
 
-import java.net.URI;
 import java.util.Iterator;
 import java.util.Map;
 import java.util.Set;
@@ -32,7 +31,6 @@
 import org.ametys.plugins.repository.UnknownAmetysObjectException;
 import org.ametys.plugins.repository.version.VersionableAmetysObject;
 import org.ametys.web.URIPrefixHandler;
-import org.ametys.web.renderingcontext.RenderingContext;
 import org.ametys.web.repository.content.WebContent;
 import org.ametys.web.repository.page.Page;
 import org.ametys.web.repository.site.Site;
@@ -92,7 +90,7 @@
             }
             else
             {
-                // We certainly come from a virtual page, try to get template from referer
+                // We certainly come from a virtual page, try to get template from referrer
                 Site site = _siteManager.getSite(siteName);
                 Sitemap sitemap = site.getSitemap(lang);
                 
@@ -106,7 +104,7 @@
                     {
                         Page page = sitemap.getChild(pathInSitemap.substring(0, pathInSitemap.indexOf(".html")));
                         
-                        // Get template from referer page
+                        // Get template from referrer page
                         template = page.getTemplate();
                     }
                     catch (UnknownAmetysObjectException e)
